var cp = require("child_process");
// var gulp = require("gulp");

// var { task, src, dest, series, parallel } = require("gulp");
var browserSync = require("browser-sync").create();
var Q = require("q");
// eslint-disable-next-line no-unused-vars
var chromedriver = require("chromedriver");
var webdriver = require("selenium-webdriver");
var srv = null;
var stdin = process.openStdin();
// require("tty").setRawMode(true);
stdin.setRawMode(true);

// resume stdin in the parent process (node app won't quit all by itself
// unless an error or process.exit() happens)
stdin.resume();

// i don't want binary, do you?
stdin.setEncoding("utf8");

function restartServer() {
  driverPromise.then(() => {
    if (srv) {
      srv.kill(9);
      srv = null;
    }

    // driver.getCurrentUrl().then(url => {
    //   _goptions.url = url;
    startupServer();
    // });

    console.log("restart");
  });
}
// on any data into stdin
stdin.on("data", function(key) {
  // ctrl-c ( end of text )
  if (key === "\u0003") {
    driverPromise
      .then(dr => dr.quit())
      .then(() => process.exit())
      .catch(() => {
        process.exit();
      });
  }
  if (key == "r") {
    restartServer();
  }
  // write the key to stdout all normal like
  //   process.stdout.write(key);
});
var firstTime = true;
function startupServer() {
  srv = cp.fork(_goptions.server).on("message", m => {
    if (m == "online") {
      driverPromise.then(driver => {
        if (firstTime) {
          firstTime = false;
          return driver.get(_goptions.url);
        } else {
          return driver.navigate().refresh();
        }
      })
        .then(() => console.log(`${_goptions.url} reloaded!`));
    }
  });
}
// stdin.on("keypress", function(chunk, key) { 
//   process.stdout.write("Get Chunk: " + chunk + "\n");
//   if (key && key.ctrl && key.name == "c") process.exit();
// });

// var driver = new webdriver.Builder()
//   .withCapabilities(chromeCapabilities)
//   .build();

// var chrome = require("selenium-webdriver/chrome");
var driverPromise = Q.Promise((resolve, reject) => {
  var chromeCapabilities = webdriver.Capabilities.chrome();
  //setting chrome options to start the browser fully maximized
  var chromeOptions = {
    args: [
      // "--test-type",
      "--start-maximized",
      // "--aggressive-cache-discard",
      // "--disable-notifications",
      // "--disable-remote-playback-api",
      // "--disable-voice-input",
      // "--enable-aggressive-domstorage-flushing",
      // "–-disable-application-cache",
      // "-–media-cache-size=1",
      // "-–disk-cache-size=1"
    ]
  };
  chromeCapabilities.set("chromeOptions", chromeOptions);
  //   cap.addArguments([" --disable-notifications"]);
  return (
    new webdriver.Builder()
      .forBrowser("chrome")
      .withCapabilities(chromeCapabilities)
      //   .build()
      //   .setChromeOptions(
      //     chrome.setChromeOptions(
      //       new chrome.Options().addArguments(["--aggressive-cache-discard"])
      //     )
      //   )
      // .setChromeOptions(cap)
      // .addArguments([
      //   " --aggressive-cache-discard",
      //   " --disable-notifications",
      //   " --disable-remote-fonts --disable-reading-from-canvas --disable-remote-playback-api --disable-shared-workers --disable-voice-input --enable-aggressive-domstorage-flushing"
      // ])

      .build()
      .then(driver => driver.getSession().then(() => driver))
      .then(driver => resolve(driver))
      .catch(e => {
        reject(e);
        console.error(e);
      })
  );
}).catch(console.error);

// var sass = require("gulp-sass");

// Static Server + watching scss/html files
// gulp.task("serve", ["sass"], function() {
//   browserSync.init({
//     server: "./"
//   });

//   gulp.watch("app/scss/*.scss", ["sass"]);
//   return gulp.watch("pages/**/*").on("change", () => {
//     driverPromise.then(driver => driver.get("http://localhost:3000"));
//   });
// });

// Compile sass into CSS & auto-inject into browsers

var _goptions;
class ChromeDev {
  constructor(opt) {
    opt.setup = opt.setup || this.noop;
    this.options = opt;
    // this.gulp = gulp;
    this.browserSync = browserSync;
    _goptions = opt;
    this.tm = setTimeout(function () { }, 10);
    this.bsOptions = {
      ignoreInitial: true,
      ignored: [
        /node_modules/,
        /\.marko\.js/,
        /\.cache/,
        /\.git/,
        /\.sass-cache/,
        /\.vscode/,
        /\.git/,
        /\.idea/
      ]
    };
    this.watchList = [];
    // if (fs.existsSync(".gitignore")) {
    //   this.bsOptions = this.bsOptions.concat(fs.readFileSync(".gitignore").split('\n').map(s => new RegExp(s)));
    // }
  }
  ignore(items) {
    this.bsOptions.ignored = this.bsOptions.ignored.concat(items);
    return this;
  }
  watch(fn) {
    this.watchList.push(fn);

    return this;
  }
  //restart server
  restart() {
    var me = this;
    clearTimeout(this.tm);
    Q.Promise(resolve => {
      if (me.options.beforeRestart) {
        me.options.beforeRestart(this).then(() => resolve()).catch(() => resolve());
      } else {
        resolve();
      }

    }).then(() => {
      this.tm = setTimeout(() => {
        driverPromise.then(() => {
          restartServer();
        });
      }, 500);
    })



  }

  run() {
    var me = this;
    Q.resolve()
      .then(() => {
        if (me.options.setup) {
          return me.options.setup.call(me, me);
        }
        return Q.resolve();
      })
      .then(() => {
        return Q.Promise(resolve => {
          me.browserSync.watch(".", me.bsOptions, (e, f) => {
            Q.all(
              me.watchList.map(fn => {
                return fn.call(me, e, f);
              })
            )
              .then(() => me.restart())
              .catch();
          });
          resolve();
        });
      })
      .then(() => {
        console.info("chrome dev initalize finish");

        startupServer();
        // gulp.parallel([this.options.gulpDevTaskName]);
        // gulp.task('boot-task', [this.options.gulpDevTaskName], function callbackForAsyncTasks(done) {
        //   console.log("run run run")
        //   done()
        // });
      })

      .catch(console.error);
  }
}
module.exports = function (options) {
  new ChromeDev(options).run();
};

// gulp.series("default", function() {
//   console.log("default");
// });
// gulp.task("default", ["serve"]);
// gulp.start("default");
