var chromedriver = require("chromedriver");
var webdriver = require("selenium-webdriver");
var Q = require("q");
var driverPromise = Q.Promise((resolve, reject) => {
    var chromeCapabilities = webdriver.Capabilities.chrome();
    //setting chrome options to start the browser fully maximized
    var chromeOptions = {
        args: [
            "--test-type",
            "--start-maximized",
            // "--aggressive-cache-discard",
            // "--disable-notifications",
            // "--disable-remote-playback-api",
            // "--disable-voice-input",
            // "--enable-aggressive-domstorage-flushing",
            // "–-disable-application-cache",
            // "-–media-cache-size=1",
            // "-–disk-cache-size=1"
        ]
    };
    chromeCapabilities.set("chromeOptions", chromeOptions);
    //   cap.addArguments([" --disable-notifications"]);
    return (
        new webdriver.Builder()
            .forBrowser("chrome")
            .withCapabilities(chromeCapabilities)
            //   .build()
            //   .setChromeOptions(
            //     chrome.setChromeOptions(
            //       new chrome.Options().addArguments(["--aggressive-cache-discard"])
            //     )
            //   )
            // .setChromeOptions(cap)
            // .addArguments([
            //   " --aggressive-cache-discard",
            //   " --disable-notifications",
            //   " --disable-remote-fonts --disable-reading-from-canvas --disable-remote-playback-api --disable-shared-workers --disable-voice-input --enable-aggressive-domstorage-flushing"
            // ])

            .build()
            .then(driver => driver.getSession().then(() => driver))
            .then(driver => resolve(driver))
            .catch(e => {
                reject(e);
                console.error(e);
            })
    );
}).catch(console.error);
function injectScript(path) {
    var sc = document.createElement("script");
    sc.src = path;
    document.body.append(sc);
}
function buildjs(name, ...args) {
    var paras = args.map(o => JSON.stringify(o));
    var script = `(${injectScript + ""}).call(null,${paras})`;
    return script;
}
class ChromeBrowser {
    constructor() {
        this.driverPromise = driverPromise;
    }

    url(url) {
        return driverPromise.then((driver) => {
            return driver.get(url);
            // .then(() => {
            //     // var path = "he he";
            //     // var script = `${injectScript + ""}.call(null,${JSON.stringify(path)})`;
            //     var script = buildjs("injectScript", "some pa ram", 123, 456)
            //     // console.log(script);
            //     return driver.executeScript(script);
            // });
        });
    }
    reload() {
        return driverPromise.then(driver => {
            return driver.navigate().refresh();
        });
    }
    quit() {
        return driverPromise.then((driver) => {
            return driver.quit();
        });
    }
    get currentUrl() {
        return driverPromise.then((driver) => {
            return driver.executeScript("return location.href");
        });
    }

}
module.exports = new ChromeBrowser()